/* Generated by wayland-scanner 1.23.0 */

#ifndef DESQ_SHELL_UNSTABLE_V1_CLIENT_PROTOCOL_H
#define DESQ_SHELL_UNSTABLE_V1_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_desq_shell_unstable_v1 The desq_shell_unstable_v1 protocol
 * @section page_ifaces_desq_shell_unstable_v1 Interfaces
 * - @subpage page_iface_zdesq_shell_manager_v1 - A simple protocol to facilitate DE integration
 * - @subpage page_iface_zdesq_output_v1 - A wrapper for wl_output
 * - @subpage page_iface_zdesq_hotspot_v1 - An edge of the output defined by 1 or 2 edges
 * - @subpage page_iface_zdesq_surface_v1 - A special surface
 * - @subpage page_iface_zdesq_panel_v1 - A normal view that is designated for use as a panel.
 * @section page_copyright_desq_shell_unstable_v1 Copyright
 * <pre>
 *
 * Copyright © 2018 Ilia Bozhinov
 * Copyright © 2023 Marcus Britanicus
 *
 * Permission to use, copy, modify, distribute, and sell this
 * software and its documentation for any purpose is hereby granted
 * without fee, provided that the above copyright notice appear in
 * all copies and that both that copyright notice and this permission
 * notice appear in supporting documentation, and that the name of
 * the copyright holders not be used in advertising or publicity
 * pertaining to distribution of the software without specific,
 * written prior permission.  The copyright holders make no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied
 * warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
 * THIS SOFTWARE.
 * </pre>
 */
struct wl_output;
struct wl_surface;
struct zdesq_hotspot_v1;
struct zdesq_output_v1;
struct zdesq_panel_v1;
struct zdesq_shell_manager_v1;
struct zdesq_surface_v1;

#ifndef ZDESQ_SHELL_MANAGER_V1_INTERFACE
#define ZDESQ_SHELL_MANAGER_V1_INTERFACE
/**
 * @page page_iface_zdesq_shell_manager_v1 zdesq_shell_manager_v1
 * @section page_iface_zdesq_shell_manager_v1_desc Description
 *
 * This protocol provides additional events and requests for special DE
 * clients like panels, docks, etc.
 *
 * It is meant as an alternative for protocols like wlr-layer-shell.
 * @section page_iface_zdesq_shell_manager_v1_api API
 * See @ref iface_zdesq_shell_manager_v1.
 */
/**
 * @defgroup iface_zdesq_shell_manager_v1 The zdesq_shell_manager_v1 interface
 *
 * This protocol provides additional events and requests for special DE
 * clients like panels, docks, etc.
 *
 * It is meant as an alternative for protocols like wlr-layer-shell.
 */
extern const struct wl_interface zdesq_shell_manager_v1_interface;
#endif
#ifndef ZDESQ_OUTPUT_V1_INTERFACE
#define ZDESQ_OUTPUT_V1_INTERFACE
/**
 * @page page_iface_zdesq_output_v1 zdesq_output_v1
 * @section page_iface_zdesq_output_v1_desc Description
 *
 * Represents a single output. Each output is managed independent of the others.
 * This interface also provides information about the workspaces of this output,
 * and views shown on this output. Additionally, it is possible to define
 * hotspots for each output.
 * @section page_iface_zdesq_output_v1_api API
 * See @ref iface_zdesq_output_v1.
 */
/**
 * @defgroup iface_zdesq_output_v1 The zdesq_output_v1 interface
 *
 * Represents a single output. Each output is managed independent of the others.
 * This interface also provides information about the workspaces of this output,
 * and views shown on this output. Additionally, it is possible to define
 * hotspots for each output.
 */
extern const struct wl_interface zdesq_output_v1_interface;
#endif
#ifndef ZDESQ_HOTSPOT_V1_INTERFACE
#define ZDESQ_HOTSPOT_V1_INTERFACE
/**
 * @page page_iface_zdesq_hotspot_v1 zdesq_hotspot_v1
 * @section page_iface_zdesq_hotspot_v1_desc Description
 * @section page_iface_zdesq_hotspot_v1_api API
 * See @ref iface_zdesq_hotspot_v1.
 */
/**
 * @defgroup iface_zdesq_hotspot_v1 The zdesq_hotspot_v1 interface
 */
extern const struct wl_interface zdesq_hotspot_v1_interface;
#endif
#ifndef ZDESQ_SURFACE_V1_INTERFACE
#define ZDESQ_SURFACE_V1_INTERFACE
/**
 * @page page_iface_zdesq_surface_v1 zdesq_surface_v1
 * @section page_iface_zdesq_surface_v1_desc Description
 * @section page_iface_zdesq_surface_v1_api API
 * See @ref iface_zdesq_surface_v1.
 */
/**
 * @defgroup iface_zdesq_surface_v1 The zdesq_surface_v1 interface
 */
extern const struct wl_interface zdesq_surface_v1_interface;
#endif
#ifndef ZDESQ_PANEL_V1_INTERFACE
#define ZDESQ_PANEL_V1_INTERFACE
/**
 * @page page_iface_zdesq_panel_v1 zdesq_panel_v1
 * @section page_iface_zdesq_panel_v1_desc Description
 * @section page_iface_zdesq_panel_v1_api API
 * See @ref iface_zdesq_panel_v1.
 */
/**
 * @defgroup iface_zdesq_panel_v1 The zdesq_panel_v1 interface
 */
extern const struct wl_interface zdesq_panel_v1_interface;
#endif

#define ZDESQ_SHELL_MANAGER_V1_GET_DESQ_OUTPUT 0
#define ZDESQ_SHELL_MANAGER_V1_GET_DESQ_SURFACE 1
#define ZDESQ_SHELL_MANAGER_V1_SET_BACKGROUND 2
#define ZDESQ_SHELL_MANAGER_V1_SET_DROPDOWN 3
#define ZDESQ_SHELL_MANAGER_V1_CREATE_PANEL 4


/**
 * @ingroup iface_zdesq_shell_manager_v1
 */
#define ZDESQ_SHELL_MANAGER_V1_GET_DESQ_OUTPUT_SINCE_VERSION 1
/**
 * @ingroup iface_zdesq_shell_manager_v1
 */
#define ZDESQ_SHELL_MANAGER_V1_GET_DESQ_SURFACE_SINCE_VERSION 1
/**
 * @ingroup iface_zdesq_shell_manager_v1
 */
#define ZDESQ_SHELL_MANAGER_V1_SET_BACKGROUND_SINCE_VERSION 1
/**
 * @ingroup iface_zdesq_shell_manager_v1
 */
#define ZDESQ_SHELL_MANAGER_V1_SET_DROPDOWN_SINCE_VERSION 1
/**
 * @ingroup iface_zdesq_shell_manager_v1
 */
#define ZDESQ_SHELL_MANAGER_V1_CREATE_PANEL_SINCE_VERSION 1

/** @ingroup iface_zdesq_shell_manager_v1 */
static inline void
zdesq_shell_manager_v1_set_user_data(struct zdesq_shell_manager_v1 *zdesq_shell_manager_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zdesq_shell_manager_v1, user_data);
}

/** @ingroup iface_zdesq_shell_manager_v1 */
static inline void *
zdesq_shell_manager_v1_get_user_data(struct zdesq_shell_manager_v1 *zdesq_shell_manager_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zdesq_shell_manager_v1);
}

static inline uint32_t
zdesq_shell_manager_v1_get_version(struct zdesq_shell_manager_v1 *zdesq_shell_manager_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) zdesq_shell_manager_v1);
}

/** @ingroup iface_zdesq_shell_manager_v1 */
static inline void
zdesq_shell_manager_v1_destroy(struct zdesq_shell_manager_v1 *zdesq_shell_manager_v1)
{
	wl_proxy_destroy((struct wl_proxy *) zdesq_shell_manager_v1);
}

/**
 * @ingroup iface_zdesq_shell_manager_v1
 */
static inline struct zdesq_output_v1 *
zdesq_shell_manager_v1_get_desq_output(struct zdesq_shell_manager_v1 *zdesq_shell_manager_v1, struct wl_output *output)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_flags((struct wl_proxy *) zdesq_shell_manager_v1,
			 ZDESQ_SHELL_MANAGER_V1_GET_DESQ_OUTPUT, &zdesq_output_v1_interface, wl_proxy_get_version((struct wl_proxy *) zdesq_shell_manager_v1), 0, output, NULL);

	return (struct zdesq_output_v1 *) id;
}

/**
 * @ingroup iface_zdesq_shell_manager_v1
 */
static inline struct zdesq_surface_v1 *
zdesq_shell_manager_v1_get_desq_surface(struct zdesq_shell_manager_v1 *zdesq_shell_manager_v1, struct wl_surface *surface)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_flags((struct wl_proxy *) zdesq_shell_manager_v1,
			 ZDESQ_SHELL_MANAGER_V1_GET_DESQ_SURFACE, &zdesq_surface_v1_interface, wl_proxy_get_version((struct wl_proxy *) zdesq_shell_manager_v1), 0, surface, NULL);

	return (struct zdesq_surface_v1 *) id;
}

/**
 * @ingroup iface_zdesq_shell_manager_v1
 *
 * Set this view as the desktop background for the given output. If this request is
 * made multiple times for the same output, then the last surface will be used. All
 * other surfaces will be closed. If the output is null, then the background will be
 * set for the active desktop.
 */
static inline void
zdesq_shell_manager_v1_set_background(struct zdesq_shell_manager_v1 *zdesq_shell_manager_v1, struct wl_surface *surface, struct wl_output *output)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zdesq_shell_manager_v1,
			 ZDESQ_SHELL_MANAGER_V1_SET_BACKGROUND, NULL, wl_proxy_get_version((struct wl_proxy *) zdesq_shell_manager_v1), 0, surface, output);
}

/**
 * @ingroup iface_zdesq_shell_manager_v1
 *
 * You may pass NULL for output to allow the compositor to decide which output
 * to use. If the output is null, active output will be used. Multiple views can
 * be set as dropdown.
 * TODO: Optionally register a keybinding
 */
static inline void
zdesq_shell_manager_v1_set_dropdown(struct zdesq_shell_manager_v1 *zdesq_shell_manager_v1, struct wl_output *output, struct wl_surface *surface)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zdesq_shell_manager_v1,
			 ZDESQ_SHELL_MANAGER_V1_SET_DROPDOWN, NULL, wl_proxy_get_version((struct wl_proxy *) zdesq_shell_manager_v1), 0, output, surface);
}

/**
 * @ingroup iface_zdesq_shell_manager_v1
 */
static inline struct zdesq_panel_v1 *
zdesq_shell_manager_v1_create_panel(struct zdesq_shell_manager_v1 *zdesq_shell_manager_v1, struct wl_output *output, struct wl_surface *surface)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_flags((struct wl_proxy *) zdesq_shell_manager_v1,
			 ZDESQ_SHELL_MANAGER_V1_CREATE_PANEL, &zdesq_panel_v1_interface, wl_proxy_get_version((struct wl_proxy *) zdesq_shell_manager_v1), 0, output, surface, NULL);

	return (struct zdesq_panel_v1 *) id;
}

#ifndef ZDESQ_OUTPUT_V1_HOTSPOT_EDGE_ENUM
#define ZDESQ_OUTPUT_V1_HOTSPOT_EDGE_ENUM
enum zdesq_output_v1_hotspot_edge {
	ZDESQ_OUTPUT_V1_HOTSPOT_EDGE_TOP = 1,
	ZDESQ_OUTPUT_V1_HOTSPOT_EDGE_BOTTOM = 2,
	ZDESQ_OUTPUT_V1_HOTSPOT_EDGE_LEFT = 4,
	ZDESQ_OUTPUT_V1_HOTSPOT_EDGE_RIGHT = 8,
};
#endif /* ZDESQ_OUTPUT_V1_HOTSPOT_EDGE_ENUM */

/**
 * @ingroup iface_zdesq_output_v1
 * @struct zdesq_output_v1_listener
 */
struct zdesq_output_v1_listener {
	/**
	 * A window was fullscreened
	 *
	 * Emitted when a window gets fullscreened on the given output.
	 * In this mode, windows in the TOP layer are not visible.
	 *
	 * There will be no two consecutive enter_fullscreen calls, i.e. if
	 * fullscreen mode is entered it will be exited before going into
	 * this mode again.
	 */
	void (*enter_fullscreen)(void *data,
				 struct zdesq_output_v1 *zdesq_output_v1);
	/**
	 * A window was un-fullscreened
	 *
	 * Emitted when the output is no longer in fullscreen mode. Each
	 * leave_fullscreen has a corresponding enter_fullscreen before it.
	 */
	void (*leave_fullscreen)(void *data,
				 struct zdesq_output_v1 *zdesq_output_v1);
	/**
	 * The current size of the workspace grid
	 *
	 * This event is emitted immediately after the zdesq_output_v1
	 * object is bound. The event will also be emitted in response to
	 * get_workspace_extents request and whenever the workspace grid
	 * size changes.
	 * @param rows number of rows the current workspace grid contains
	 * @param columns number of columns the current workspace grid contains
	 */
	void (*workspace_extents)(void *data,
				  struct zdesq_output_v1 *zdesq_output_v1,
				  int32_t rows,
				  int32_t columns);
	/**
	 * The current workspace index (r, c)
	 *
	 * This event is emitted immediately after the zdesq_output_v1
	 * object is bound. The event will also be emitted in response to
	 * get_active_workspace request and whenever the active workspace
	 * changes.
	 * @param row Row in which the current workspace resides
	 * @param column Column in which the current workspace resides
	 */
	void (*active_workspace)(void *data,
				 struct zdesq_output_v1 *zdesq_output_v1,
				 int32_t row,
				 int32_t column);
	/**
	 * A view with uuid was added to workspace index (r, c)
	 *
	 * This event is emitted immediately after the a view is added on
	 * a workspace. Note that a view may be visible on multiple
	 * workspaces, and multiple outputs. When a view is no longer
	 * visible on a workspace, view_remove event will be sent with the
	 * corresponding workspace row, column. You may use the UUID to
	 * obtain the information about the view using the
	 * wayfire-toplevel-management-v1 protocol.
	 * @param view_uuid UUID of the view which was added
	 * @param row Row of the workspace in which the view was added
	 * @param column Column of the workspace in which the view was added
	 */
	void (*view_added)(void *data,
			   struct zdesq_output_v1 *zdesq_output_v1,
			   uint32_t view_uuid,
			   int32_t row,
			   int32_t column);
	/**
	 * A view with uuid was removed workspace index (r, c)
	 *
	 * This event is emitted immediately after the a view is removed
	 * from a workspace. This event does not mean that the view was
	 * closed, or removed from this output. but simply that the view is
	 * no longer visible on the workspace (r, c). A view may be visible
	 * on more than one workspaces and outputs.
	 * @param view_uuid UUID of the view which was added
	 * @param row Row of the workspace in which the view was added
	 * @param column Column of the workspace in which the view was added
	 */
	void (*view_removed)(void *data,
			     struct zdesq_output_v1 *zdesq_output_v1,
			     uint32_t view_uuid,
			     int32_t row,
			     int32_t column);
	/**
	 * The compositor is done sending the events
	 *
	 * This event is sent once the compositor is done sending the
	 * infortmation. For example, when zdesq_output_v1 is first bound,
	 * the compositor will send the workspace_extents, followed by
	 * active_workspace event. Once the workspace related events are
	 * sent, view_added events will be sent for each view. Finally,
	 * this event will be sent. Clients are advised to wait until they
	 * recieve this event to commit any changes required.
	 */
	void (*done)(void *data,
		     struct zdesq_output_v1 *zdesq_output_v1);
};

/**
 * @ingroup iface_zdesq_output_v1
 */
static inline int
zdesq_output_v1_add_listener(struct zdesq_output_v1 *zdesq_output_v1,
			     const struct zdesq_output_v1_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) zdesq_output_v1,
				     (void (**)(void)) listener, data);
}

#define ZDESQ_OUTPUT_V1_INHIBIT_OUTPUT 0
#define ZDESQ_OUTPUT_V1_INHIBIT_OUTPUT_DONE 1
#define ZDESQ_OUTPUT_V1_CREATE_HOTSPOT 2
#define ZDESQ_OUTPUT_V1_GET_WORKSPACE_EXTENTS 3
#define ZDESQ_OUTPUT_V1_GET_ACTIVE_WORKSPACE 4
#define ZDESQ_OUTPUT_V1_SET_ACTIVE_WORKSPACE 5

/**
 * @ingroup iface_zdesq_output_v1
 */
#define ZDESQ_OUTPUT_V1_ENTER_FULLSCREEN_SINCE_VERSION 1
/**
 * @ingroup iface_zdesq_output_v1
 */
#define ZDESQ_OUTPUT_V1_LEAVE_FULLSCREEN_SINCE_VERSION 1
/**
 * @ingroup iface_zdesq_output_v1
 */
#define ZDESQ_OUTPUT_V1_WORKSPACE_EXTENTS_SINCE_VERSION 1
/**
 * @ingroup iface_zdesq_output_v1
 */
#define ZDESQ_OUTPUT_V1_ACTIVE_WORKSPACE_SINCE_VERSION 1
/**
 * @ingroup iface_zdesq_output_v1
 */
#define ZDESQ_OUTPUT_V1_VIEW_ADDED_SINCE_VERSION 1
/**
 * @ingroup iface_zdesq_output_v1
 */
#define ZDESQ_OUTPUT_V1_VIEW_REMOVED_SINCE_VERSION 1
/**
 * @ingroup iface_zdesq_output_v1
 */
#define ZDESQ_OUTPUT_V1_DONE_SINCE_VERSION 1

/**
 * @ingroup iface_zdesq_output_v1
 */
#define ZDESQ_OUTPUT_V1_INHIBIT_OUTPUT_SINCE_VERSION 1
/**
 * @ingroup iface_zdesq_output_v1
 */
#define ZDESQ_OUTPUT_V1_INHIBIT_OUTPUT_DONE_SINCE_VERSION 1
/**
 * @ingroup iface_zdesq_output_v1
 */
#define ZDESQ_OUTPUT_V1_CREATE_HOTSPOT_SINCE_VERSION 1
/**
 * @ingroup iface_zdesq_output_v1
 */
#define ZDESQ_OUTPUT_V1_GET_WORKSPACE_EXTENTS_SINCE_VERSION 1
/**
 * @ingroup iface_zdesq_output_v1
 */
#define ZDESQ_OUTPUT_V1_GET_ACTIVE_WORKSPACE_SINCE_VERSION 1
/**
 * @ingroup iface_zdesq_output_v1
 */
#define ZDESQ_OUTPUT_V1_SET_ACTIVE_WORKSPACE_SINCE_VERSION 1

/** @ingroup iface_zdesq_output_v1 */
static inline void
zdesq_output_v1_set_user_data(struct zdesq_output_v1 *zdesq_output_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zdesq_output_v1, user_data);
}

/** @ingroup iface_zdesq_output_v1 */
static inline void *
zdesq_output_v1_get_user_data(struct zdesq_output_v1 *zdesq_output_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zdesq_output_v1);
}

static inline uint32_t
zdesq_output_v1_get_version(struct zdesq_output_v1 *zdesq_output_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) zdesq_output_v1);
}

/** @ingroup iface_zdesq_output_v1 */
static inline void
zdesq_output_v1_destroy(struct zdesq_output_v1 *zdesq_output_v1)
{
	wl_proxy_destroy((struct wl_proxy *) zdesq_output_v1);
}

/**
 * @ingroup iface_zdesq_output_v1
 *
 * Request the compositor to not render the output, so the output usually
 * is cleared to black color. To enable output rendering again, call
 * inhibit_output_done.
 */
static inline void
zdesq_output_v1_inhibit_output(struct zdesq_output_v1 *zdesq_output_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zdesq_output_v1,
			 ZDESQ_OUTPUT_V1_INHIBIT_OUTPUT, NULL, wl_proxy_get_version((struct wl_proxy *) zdesq_output_v1), 0);
}

/**
 * @ingroup iface_zdesq_output_v1
 *
 * Stop inhibiting the output. This must be called as many times as
 * inhibit_output was called to actually uninhibit rendering.
 *
 * The inhibit/inhibit_done requests can be called multiple times, even
 * from different apps, so don't assume that a call to inhibit_done would
 * always mean actually starting the rendering process.
 */
static inline void
zdesq_output_v1_inhibit_output_done(struct zdesq_output_v1 *zdesq_output_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zdesq_output_v1,
			 ZDESQ_OUTPUT_V1_INHIBIT_OUTPUT_DONE, NULL, wl_proxy_get_version((struct wl_proxy *) zdesq_output_v1), 0);
}

/**
 * @ingroup iface_zdesq_output_v1
 *
 * A hotspot on the output is an edge or a corner region of the
 * output where the mouse or touch point has been residing for a given
 * amount of time.
 *
 * The hotspot can be used for example for autohiding panels, where the
 * panel is shown when the input hovers on the edge of the output for a
 * specific amount of time.
 */
static inline struct zdesq_hotspot_v1 *
zdesq_output_v1_create_hotspot(struct zdesq_output_v1 *zdesq_output_v1, uint32_t hotspot, uint32_t threshold, uint32_t timeout)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_flags((struct wl_proxy *) zdesq_output_v1,
			 ZDESQ_OUTPUT_V1_CREATE_HOTSPOT, &zdesq_hotspot_v1_interface, wl_proxy_get_version((struct wl_proxy *) zdesq_output_v1), 0, hotspot, threshold, timeout, NULL);

	return (struct zdesq_hotspot_v1 *) id;
}

/**
 * @ingroup iface_zdesq_output_v1
 *
 * In response to this request, the compositor will send a workspace_extents event with
 * the current grid size.
 */
static inline void
zdesq_output_v1_get_workspace_extents(struct zdesq_output_v1 *zdesq_output_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zdesq_output_v1,
			 ZDESQ_OUTPUT_V1_GET_WORKSPACE_EXTENTS, NULL, wl_proxy_get_version((struct wl_proxy *) zdesq_output_v1), 0);
}

/**
 * @ingroup iface_zdesq_output_v1
 *
 * In response to this request, the compositor will send a active_workspace event with
 * the current index. Note that the first row and first column will be (0, 0).
 */
static inline void
zdesq_output_v1_get_active_workspace(struct zdesq_output_v1 *zdesq_output_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zdesq_output_v1,
			 ZDESQ_OUTPUT_V1_GET_ACTIVE_WORKSPACE, NULL, wl_proxy_get_version((struct wl_proxy *) zdesq_output_v1), 0);
}

/**
 * @ingroup iface_zdesq_output_v1
 *
 * In response to this request, the compositor will, if valid, set the active
 * workspace the index specified by (row, column). If successful, you'll receive the
 * active_workspace event. Note that the first row and first column will be (0, 0).
 */
static inline void
zdesq_output_v1_set_active_workspace(struct zdesq_output_v1 *zdesq_output_v1, int32_t row, int32_t column)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zdesq_output_v1,
			 ZDESQ_OUTPUT_V1_SET_ACTIVE_WORKSPACE, NULL, wl_proxy_get_version((struct wl_proxy *) zdesq_output_v1), 0, row, column);
}

/**
 * @ingroup iface_zdesq_hotspot_v1
 * @struct zdesq_hotspot_v1_listener
 */
struct zdesq_hotspot_v1_listener {
	/**
	 * Hotspot was triggered
	 *
	 * Means that the mouse and/or touch finger was inside the
	 * indicated hotspot for the given amount of time.
	 *
	 * Emitted at most once for each entry of the input inside the
	 * hotspot.
	 */
	void (*enter)(void *data,
		      struct zdesq_hotspot_v1 *zdesq_hotspot_v1);
	/**
	 * Input left hotspot
	 *
	 * This event indicates that the mouse or touch point has left
	 * the hotspot area.
	 *
	 * Emitted only once after each enter.
	 */
	void (*leave)(void *data,
		      struct zdesq_hotspot_v1 *zdesq_hotspot_v1);
};

/**
 * @ingroup iface_zdesq_hotspot_v1
 */
static inline int
zdesq_hotspot_v1_add_listener(struct zdesq_hotspot_v1 *zdesq_hotspot_v1,
			      const struct zdesq_hotspot_v1_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) zdesq_hotspot_v1,
				     (void (**)(void)) listener, data);
}

/**
 * @ingroup iface_zdesq_hotspot_v1
 */
#define ZDESQ_HOTSPOT_V1_ENTER_SINCE_VERSION 1
/**
 * @ingroup iface_zdesq_hotspot_v1
 */
#define ZDESQ_HOTSPOT_V1_LEAVE_SINCE_VERSION 1


/** @ingroup iface_zdesq_hotspot_v1 */
static inline void
zdesq_hotspot_v1_set_user_data(struct zdesq_hotspot_v1 *zdesq_hotspot_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zdesq_hotspot_v1, user_data);
}

/** @ingroup iface_zdesq_hotspot_v1 */
static inline void *
zdesq_hotspot_v1_get_user_data(struct zdesq_hotspot_v1 *zdesq_hotspot_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zdesq_hotspot_v1);
}

static inline uint32_t
zdesq_hotspot_v1_get_version(struct zdesq_hotspot_v1 *zdesq_hotspot_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) zdesq_hotspot_v1);
}

/** @ingroup iface_zdesq_hotspot_v1 */
static inline void
zdesq_hotspot_v1_destroy(struct zdesq_hotspot_v1 *zdesq_hotspot_v1)
{
	wl_proxy_destroy((struct wl_proxy *) zdesq_hotspot_v1);
}

#define ZDESQ_SURFACE_V1_INTERACTIVE_MOVE 0


/**
 * @ingroup iface_zdesq_surface_v1
 */
#define ZDESQ_SURFACE_V1_INTERACTIVE_MOVE_SINCE_VERSION 1

/** @ingroup iface_zdesq_surface_v1 */
static inline void
zdesq_surface_v1_set_user_data(struct zdesq_surface_v1 *zdesq_surface_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zdesq_surface_v1, user_data);
}

/** @ingroup iface_zdesq_surface_v1 */
static inline void *
zdesq_surface_v1_get_user_data(struct zdesq_surface_v1 *zdesq_surface_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zdesq_surface_v1);
}

static inline uint32_t
zdesq_surface_v1_get_version(struct zdesq_surface_v1 *zdesq_surface_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) zdesq_surface_v1);
}

/** @ingroup iface_zdesq_surface_v1 */
static inline void
zdesq_surface_v1_destroy(struct zdesq_surface_v1 *zdesq_surface_v1)
{
	wl_proxy_destroy((struct wl_proxy *) zdesq_surface_v1);
}

/**
 * @ingroup iface_zdesq_surface_v1
 */
static inline void
zdesq_surface_v1_interactive_move(struct zdesq_surface_v1 *zdesq_surface_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zdesq_surface_v1,
			 ZDESQ_SURFACE_V1_INTERACTIVE_MOVE, NULL, wl_proxy_get_version((struct wl_proxy *) zdesq_surface_v1), 0);
}

#ifndef ZDESQ_PANEL_V1_PANEL_BEHAVIOR_ENUM
#define ZDESQ_PANEL_V1_PANEL_BEHAVIOR_ENUM
/**
 * @ingroup iface_zdesq_panel_v1
 * Behavior for panel surface
 *
 * This enum explains how the panel interacts with the views.
 *
 * When the panel is always visible, an exclusive zone is set up which is
 * equal to the panel thickness. All maximized views can use an area that
 * is the screen area minux the panel area.
 *
 * In the smart_auto_hide mode, the panel decides whether to be visible or
 * not. If a any view retangle intersets the panel rectangle, the panel is
 * hidden. When no view rectangle intersects the panel rectangle, the panel
 * is shown again.
 *
 * Setting the panel to windows_can_cover mode make the panel be the bottom
 * layer. When the mouse pointer enters the panel rectangle area, the panel
 * begins to be shownn. When the mouse reaches the panel edge, or the visible
 * part of the panel, the (rest of the) panel is shown. Once the mouse exits
 * the panel rectangle, the panel is hidden again.
 *
 * Setting the panel behaviour to windows_go_below makes the panel be the top
 * layer. When the active view is maximized, the panel is hidden. On view
 * unmaximized, or on another view being focused, the panel is shown.
 */
enum zdesq_panel_v1_panel_behavior {
	/**
	 * normal panel visibility
	 */
	ZDESQ_PANEL_V1_PANEL_BEHAVIOR_ALWAYS_VISIBLE = 1,
	/**
	 * hide automatically
	 */
	ZDESQ_PANEL_V1_PANEL_BEHAVIOR_SMART_AUTO_HIDE = 2,
	/**
	 * windows can cover
	 */
	ZDESQ_PANEL_V1_PANEL_BEHAVIOR_WINDOWS_CAN_COVER = 3,
	/**
	 * windows go below
	 */
	ZDESQ_PANEL_V1_PANEL_BEHAVIOR_WINDOWS_GO_BELOW = 4,
};
#endif /* ZDESQ_PANEL_V1_PANEL_BEHAVIOR_ENUM */

#ifndef ZDESQ_PANEL_V1_PANEL_POSITION_ENUM
#define ZDESQ_PANEL_V1_PANEL_POSITION_ENUM
/**
 * @ingroup iface_zdesq_panel_v1
 * Position of the panel surface
 *
 * These enums represent the bitwise-or of the edges the output to which
 * the panel will be tethered. The panel may be anchored to any one of the
 * edges, or to any two consecutive edges. Any other combination is
 * protocol error.
 *
 * By default, the panel is anchored to the top edge of the output.
 *
 * When the panel is anchored to a single edge, it will be centered on that
 * edge. When the panel is tethered to two edges, it will be anchored to
 * the edge parallel to the orientation and aligned to the other edge.
 */
enum zdesq_panel_v1_panel_position {
	ZDESQ_PANEL_V1_PANEL_POSITION_TOP = 1,
	ZDESQ_PANEL_V1_PANEL_POSITION_BOTTOM = 2,
	ZDESQ_PANEL_V1_PANEL_POSITION_LEFT = 4,
	ZDESQ_PANEL_V1_PANEL_POSITION_RIGHT = 8,
};
#endif /* ZDESQ_PANEL_V1_PANEL_POSITION_ENUM */

#ifndef ZDESQ_PANEL_V1_PANEL_ORIENTATION_ENUM
#define ZDESQ_PANEL_V1_PANEL_ORIENTATION_ENUM
/**
 * @ingroup iface_zdesq_panel_v1
 * Orientation of the panel surface
 *
 * The default orientation of the panel is horizontal.
 */
enum zdesq_panel_v1_panel_orientation {
	ZDESQ_PANEL_V1_PANEL_ORIENTATION_HORIZONTAL = 1,
	ZDESQ_PANEL_V1_PANEL_ORIENTATION_VERTICAL = 2,
};
#endif /* ZDESQ_PANEL_V1_PANEL_ORIENTATION_ENUM */

#define ZDESQ_PANEL_V1_SET_PANEL_SIZE 0
#define ZDESQ_PANEL_V1_SET_PANEL_BEHAVIOR 1
#define ZDESQ_PANEL_V1_SET_PANEL_POSITION 2
#define ZDESQ_PANEL_V1_SET_PANEL_ORIENTATION 3


/**
 * @ingroup iface_zdesq_panel_v1
 */
#define ZDESQ_PANEL_V1_SET_PANEL_SIZE_SINCE_VERSION 1
/**
 * @ingroup iface_zdesq_panel_v1
 */
#define ZDESQ_PANEL_V1_SET_PANEL_BEHAVIOR_SINCE_VERSION 1
/**
 * @ingroup iface_zdesq_panel_v1
 */
#define ZDESQ_PANEL_V1_SET_PANEL_POSITION_SINCE_VERSION 1
/**
 * @ingroup iface_zdesq_panel_v1
 */
#define ZDESQ_PANEL_V1_SET_PANEL_ORIENTATION_SINCE_VERSION 1

/** @ingroup iface_zdesq_panel_v1 */
static inline void
zdesq_panel_v1_set_user_data(struct zdesq_panel_v1 *zdesq_panel_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zdesq_panel_v1, user_data);
}

/** @ingroup iface_zdesq_panel_v1 */
static inline void *
zdesq_panel_v1_get_user_data(struct zdesq_panel_v1 *zdesq_panel_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zdesq_panel_v1);
}

static inline uint32_t
zdesq_panel_v1_get_version(struct zdesq_panel_v1 *zdesq_panel_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) zdesq_panel_v1);
}

/** @ingroup iface_zdesq_panel_v1 */
static inline void
zdesq_panel_v1_destroy(struct zdesq_panel_v1 *zdesq_panel_v1)
{
	wl_proxy_destroy((struct wl_proxy *) zdesq_panel_v1);
}

/**
 * @ingroup iface_zdesq_panel_v1
 *
 * The panel size is simply the width of the panel when vertical, and
 * height of the panel when horizontal.
 */
static inline void
zdesq_panel_v1_set_panel_size(struct zdesq_panel_v1 *zdesq_panel_v1, uint32_t size)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zdesq_panel_v1,
			 ZDESQ_PANEL_V1_SET_PANEL_SIZE, NULL, wl_proxy_get_version((struct wl_proxy *) zdesq_panel_v1), 0, size);
}

/**
 * @ingroup iface_zdesq_panel_v1
 *
 * By default, the panel will be in always visible mode.
 * See panel_behaviour enum for details.
 */
static inline void
zdesq_panel_v1_set_panel_behavior(struct zdesq_panel_v1 *zdesq_panel_v1, uint32_t behaviour)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zdesq_panel_v1,
			 ZDESQ_PANEL_V1_SET_PANEL_BEHAVIOR, NULL, wl_proxy_get_version((struct wl_proxy *) zdesq_panel_v1), 0, behaviour);
}

/**
 * @ingroup iface_zdesq_panel_v1
 *
 * The default position of the panel is top edge.
 */
static inline void
zdesq_panel_v1_set_panel_position(struct zdesq_panel_v1 *zdesq_panel_v1, uint32_t position)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zdesq_panel_v1,
			 ZDESQ_PANEL_V1_SET_PANEL_POSITION, NULL, wl_proxy_get_version((struct wl_proxy *) zdesq_panel_v1), 0, position);
}

/**
 * @ingroup iface_zdesq_panel_v1
 */
static inline void
zdesq_panel_v1_set_panel_orientation(struct zdesq_panel_v1 *zdesq_panel_v1, uint32_t orientation)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zdesq_panel_v1,
			 ZDESQ_PANEL_V1_SET_PANEL_ORIENTATION, NULL, wl_proxy_get_version((struct wl_proxy *) zdesq_panel_v1), 0, orientation);
}

#ifdef  __cplusplus
}
#endif

#endif
