/* Generated by wayland-scanner 1.23.0 */

#ifndef ZWAYFIRE_TOPLEVEL_MANAGEMENT_V1_CLIENT_PROTOCOL_H
#define ZWAYFIRE_TOPLEVEL_MANAGEMENT_V1_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_zwayfire_toplevel_management_v1 The zwayfire_toplevel_management_v1 protocol
 * @section page_ifaces_zwayfire_toplevel_management_v1 Interfaces
 * - @subpage page_iface_zwayfire_toplevel_manager_v1 - application windows management
 * - @subpage page_iface_zwayfire_toplevel_v1 - 
 * @section page_copyright_zwayfire_toplevel_management_v1 Copyright
 * <pre>
 *
 * Copyright © 2018 Ilia Bozhinov
 * Copyright © 2023 Marcus Britanicus
 *
 * Permission to use, copy, modify, distribute, and sell this
 * software and its documentation for any purpose is hereby granted
 * without fee, provided that the above copyright notice appear in
 * all copies and that both that copyright notice and this permission
 * notice appear in supporting documentation, and that the name of
 * the copyright holders not be used in advertising or publicity
 * pertaining to distribution of the software without specific,
 * written prior permission.  The copyright holders make no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied
 * warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
 * THIS SOFTWARE.
 * </pre>
 */
struct wl_output;
struct wl_surface;
struct zwayfire_toplevel_manager_v1;
struct zwayfire_toplevel_v1;

#ifndef ZWAYFIRE_TOPLEVEL_MANAGER_V1_INTERFACE
#define ZWAYFIRE_TOPLEVEL_MANAGER_V1_INTERFACE
/**
 * @page page_iface_zwayfire_toplevel_manager_v1 zwayfire_toplevel_manager_v1
 * @section page_iface_zwayfire_toplevel_manager_v1_desc Description
 *
 * This interface manages application windows.
 * It provides requests to show and hide the desktop and emits
 * an event every time a window is created so that the client can
 * use it to manage the window. It also provides a request to
 * capture an application window.
 * @section page_iface_zwayfire_toplevel_manager_v1_api API
 * See @ref iface_zwayfire_toplevel_manager_v1.
 */
/**
 * @defgroup iface_zwayfire_toplevel_manager_v1 The zwayfire_toplevel_manager_v1 interface
 *
 * This interface manages application windows.
 * It provides requests to show and hide the desktop and emits
 * an event every time a window is created so that the client can
 * use it to manage the window. It also provides a request to
 * capture an application window.
 */
extern const struct wl_interface zwayfire_toplevel_manager_v1_interface;
#endif
#ifndef ZWAYFIRE_TOPLEVEL_V1_INTERFACE
#define ZWAYFIRE_TOPLEVEL_V1_INTERFACE
/**
 * @page page_iface_zwayfire_toplevel_v1 zwayfire_toplevel_v1
 * @section page_iface_zwayfire_toplevel_v1_api API
 * See @ref iface_zwayfire_toplevel_v1.
 */
/**
 * @defgroup iface_zwayfire_toplevel_v1 The zwayfire_toplevel_v1 interface
 */
extern const struct wl_interface zwayfire_toplevel_v1_interface;
#endif

/**
 * @ingroup iface_zwayfire_toplevel_manager_v1
 * @struct zwayfire_toplevel_manager_v1_listener
 */
struct zwayfire_toplevel_manager_v1_listener {
	/**
	 * a new toplevel has been created
	 *
	 * This event is emitted whenever a new toplevel window is
	 * created. It is emitted for all toplevels, regardless of the app
	 * that has created them.
	 *
	 * All initial details of the toplevel(title, app_id, states, etc.)
	 * will be sent immediately after this event via the corresponding
	 * events in zwlr_foreign_toplevel_handle_v1.
	 * @param uuid uuid of the newly created view
	 */
	void (*new_toplevel)(void *data,
			     struct zwayfire_toplevel_manager_v1 *zwayfire_toplevel_manager_v1,
			     struct zwayfire_toplevel_v1 *toplevel,
			     uint32_t uuid);
	/**
	 * a toplevel has been created
	 *
	 * This event is emitted whenever a toplevel info is sent. It is
	 * emitted in response to the toplevels request.
	 *
	 * All initial details of the toplevel(title, app_id, states, etc.)
	 * will be sent immediately after this event via the corresponding
	 * events in zwlr_foreign_toplevel_handle_v1.
	 * @param uuid uuid of the view
	 */
	void (*toplevel)(void *data,
			 struct zwayfire_toplevel_manager_v1 *zwayfire_toplevel_manager_v1,
			 struct zwayfire_toplevel_v1 *toplevel,
			 uint32_t uuid);
	/**
	 * the compositor has finished with the toplevel manager
	 *
	 * This event indicates that the compositor is done sending
	 * events to the clients. The server will destroy the object
	 * immediately after sending this request, so it will become
	 * invalid and the client should free any resources associated with
	 * it.
	 */
	void (*finished)(void *data,
			 struct zwayfire_toplevel_manager_v1 *zwayfire_toplevel_manager_v1);
	/**
	 * the compositor has done sending events
	 *
	 * This event indicates that the compositor is done sending
	 * events to the clients.
	 */
	void (*done)(void *data,
		     struct zwayfire_toplevel_manager_v1 *zwayfire_toplevel_manager_v1);
};

/**
 * @ingroup iface_zwayfire_toplevel_manager_v1
 */
static inline int
zwayfire_toplevel_manager_v1_add_listener(struct zwayfire_toplevel_manager_v1 *zwayfire_toplevel_manager_v1,
					  const struct zwayfire_toplevel_manager_v1_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) zwayfire_toplevel_manager_v1,
				     (void (**)(void)) listener, data);
}

#define ZWAYFIRE_TOPLEVEL_MANAGER_V1_GET_TOPLEVEL_FOR_UUID 0
#define ZWAYFIRE_TOPLEVEL_MANAGER_V1_TOPLEVELS 1
#define ZWAYFIRE_TOPLEVEL_MANAGER_V1_CAPTURE_TOPLEVEL 2
#define ZWAYFIRE_TOPLEVEL_MANAGER_V1_DISABLE_TOPLEVEL_CAPTURE 3
#define ZWAYFIRE_TOPLEVEL_MANAGER_V1_STOP 4

/**
 * @ingroup iface_zwayfire_toplevel_manager_v1
 */
#define ZWAYFIRE_TOPLEVEL_MANAGER_V1_NEW_TOPLEVEL_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_manager_v1
 */
#define ZWAYFIRE_TOPLEVEL_MANAGER_V1_TOPLEVEL_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_manager_v1
 */
#define ZWAYFIRE_TOPLEVEL_MANAGER_V1_FINISHED_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_manager_v1
 */
#define ZWAYFIRE_TOPLEVEL_MANAGER_V1_DONE_SINCE_VERSION 1

/**
 * @ingroup iface_zwayfire_toplevel_manager_v1
 */
#define ZWAYFIRE_TOPLEVEL_MANAGER_V1_GET_TOPLEVEL_FOR_UUID_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_manager_v1
 */
#define ZWAYFIRE_TOPLEVEL_MANAGER_V1_TOPLEVELS_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_manager_v1
 */
#define ZWAYFIRE_TOPLEVEL_MANAGER_V1_CAPTURE_TOPLEVEL_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_manager_v1
 */
#define ZWAYFIRE_TOPLEVEL_MANAGER_V1_DISABLE_TOPLEVEL_CAPTURE_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_manager_v1
 */
#define ZWAYFIRE_TOPLEVEL_MANAGER_V1_STOP_SINCE_VERSION 1

/** @ingroup iface_zwayfire_toplevel_manager_v1 */
static inline void
zwayfire_toplevel_manager_v1_set_user_data(struct zwayfire_toplevel_manager_v1 *zwayfire_toplevel_manager_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zwayfire_toplevel_manager_v1, user_data);
}

/** @ingroup iface_zwayfire_toplevel_manager_v1 */
static inline void *
zwayfire_toplevel_manager_v1_get_user_data(struct zwayfire_toplevel_manager_v1 *zwayfire_toplevel_manager_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zwayfire_toplevel_manager_v1);
}

static inline uint32_t
zwayfire_toplevel_manager_v1_get_version(struct zwayfire_toplevel_manager_v1 *zwayfire_toplevel_manager_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_manager_v1);
}

/** @ingroup iface_zwayfire_toplevel_manager_v1 */
static inline void
zwayfire_toplevel_manager_v1_destroy(struct zwayfire_toplevel_manager_v1 *zwayfire_toplevel_manager_v1)
{
	wl_proxy_destroy((struct wl_proxy *) zwayfire_toplevel_manager_v1);
}

/**
 * @ingroup iface_zwayfire_toplevel_manager_v1
 *
 * Create a zwayfire_toplevel_v1 object for a given view uuid. You'll get a toplevel
 * event for the corresponding toplevel.
 */
static inline void
zwayfire_toplevel_manager_v1_get_toplevel_for_uuid(struct zwayfire_toplevel_manager_v1 *zwayfire_toplevel_manager_v1, uint32_t view_uuid)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwayfire_toplevel_manager_v1,
			 ZWAYFIRE_TOPLEVEL_MANAGER_V1_GET_TOPLEVEL_FOR_UUID, NULL, wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_manager_v1), 0, view_uuid);
}

/**
 * @ingroup iface_zwayfire_toplevel_manager_v1
 *
 * List all the toplevels that are currently mapped. The toplevel event will be sent
 * for each of the mapped views and then the done event will be sent.
 */
static inline void
zwayfire_toplevel_manager_v1_toplevels(struct zwayfire_toplevel_manager_v1 *zwayfire_toplevel_manager_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwayfire_toplevel_manager_v1,
			 ZWAYFIRE_TOPLEVEL_MANAGER_V1_TOPLEVELS, NULL, wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_manager_v1), 0);
}

/**
 * @ingroup iface_zwayfire_toplevel_manager_v1
 *
 * This request captures the contents of a toplevel window with identifier view_uuid
 * and stores the captured data into a shared memory as uchar *. Use the template
 * "/shm-view-UUID", along with "UUID" as the proj_id to ftok(...) to generate the
 * key to access the shared memory. For example, if the view UUID is 123:
 * key_t key = ftok( "/shm-view-123", 123 );
 *
 * If a disable capture request has been initiated for a toplevel with this view_uuid,
 * then nothing will be stored in the memory. Once the writing is complete,
 * view_captured event will be emitted.
 */
static inline void
zwayfire_toplevel_manager_v1_capture_toplevel(struct zwayfire_toplevel_manager_v1 *zwayfire_toplevel_manager_v1, uint32_t view_uuid)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwayfire_toplevel_manager_v1,
			 ZWAYFIRE_TOPLEVEL_MANAGER_V1_CAPTURE_TOPLEVEL, NULL, wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_manager_v1), 0, view_uuid);
}

/**
 * @ingroup iface_zwayfire_toplevel_manager_v1
 *
 * This request informs the compositor to consider/discard the capture_toplevel
 * requests on a view identified by view_uuid. Once the underlying view with
 * this uuid is unmapped, this request will be invalidated.
 * NOTE: This request is applied only for the capture using this protocol.
 * wlr_screencopy protocol will still reports the contents of the view if it's
 * visible.
 */
static inline void
zwayfire_toplevel_manager_v1_disable_toplevel_capture(struct zwayfire_toplevel_manager_v1 *zwayfire_toplevel_manager_v1, uint32_t view_uuid, uint32_t state)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwayfire_toplevel_manager_v1,
			 ZWAYFIRE_TOPLEVEL_MANAGER_V1_DISABLE_TOPLEVEL_CAPTURE, NULL, wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_manager_v1), 0, view_uuid, state);
}

/**
 * @ingroup iface_zwayfire_toplevel_manager_v1
 *
 * Indicates the client no longer wishes to receive events for new toplevels.
 * However the compositor may emit further toplevel_created events, until
 * the finished event is emitted.
 *
 * The client must not send any more requests after this one.
 */
static inline void
zwayfire_toplevel_manager_v1_stop(struct zwayfire_toplevel_manager_v1 *zwayfire_toplevel_manager_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwayfire_toplevel_manager_v1,
			 ZWAYFIRE_TOPLEVEL_MANAGER_V1_STOP, NULL, wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_manager_v1), 0);
}

#ifndef ZWAYFIRE_TOPLEVEL_V1_STATE_ENUM
#define ZWAYFIRE_TOPLEVEL_V1_STATE_ENUM
enum zwayfire_toplevel_v1_state {
	ZWAYFIRE_TOPLEVEL_V1_STATE_ACTIVE = 1 << 0,
	ZWAYFIRE_TOPLEVEL_V1_STATE_MINIMIZED = 1 << 1,
	ZWAYFIRE_TOPLEVEL_V1_STATE_MAXIMIZED = 1 << 2,
	ZWAYFIRE_TOPLEVEL_V1_STATE_FULLSCREEN = 1 << 3,
	ZWAYFIRE_TOPLEVEL_V1_STATE_PIN_ABOVE = 1 << 4,
	ZWAYFIRE_TOPLEVEL_V1_STATE_PIN_BELOW = 1 << 5,
	ZWAYFIRE_TOPLEVEL_V1_STATE_STICKY = 1 << 6,
	ZWAYFIRE_TOPLEVEL_V1_STATE_DEMANDS_ATTENTION = 1 << 7,
};
#endif /* ZWAYFIRE_TOPLEVEL_V1_STATE_ENUM */

/**
 * @ingroup iface_zwayfire_toplevel_v1
 * @struct zwayfire_toplevel_v1_listener
 */
struct zwayfire_toplevel_v1_listener {
	/**
	 * the title of this view was changed
	 *
	 * Emitted when bound, changed or requested.
	 * @param old_title old title of this view
	 * @param new_title new title of this view
	 */
	void (*title_changed)(void *data,
			      struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1,
			      const char *old_title,
			      const char *new_title);
	/**
	 * app_id of this view was changed
	 *
	 * Emitted when bound, changed or requested.
	 * @param old_app_id old app_id of this view
	 * @param new_app_id new app_id of this view
	 */
	void (*app_id_changed)(void *data,
			       struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1,
			       const char *old_app_id,
			       const char *new_app_id);
	/**
	 * state of this view changed
	 *
	 * Emitted when the state of this view changes. This is the
	 * bitfield of state flags. See enum states for details.
	 * @param old_state old state of this view
	 * @param new_state new state of this view
	 */
	void (*state_changed)(void *data,
			      struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1,
			      uint32_t old_state,
			      uint32_t new_state);
	/**
	 * this view was closed
	 *
	 * This signal is emitted when the view was closed. No other
	 * events will be emitted after this event is emitted.
	 */
	void (*closed)(void *data,
		       struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1);
	/**
	 * parent of this view was changed
	 *
	 * 
	 * @param old_parent uuid of the old parent
	 * @param new_parent uuid of the new parent
	 */
	void (*parent_changed)(void *data,
			       struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1,
			       uint32_t old_parent,
			       uint32_t new_parent);
	/**
	 * geometry of the toplevel changed
	 *
	 * 
	 * @param x x position
	 * @param y y position
	 * @param width width position
	 * @param height height position
	 */
	void (*geometry_changed)(void *data,
				 struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1,
				 int32_t x,
				 int32_t y,
				 int32_t width,
				 int32_t height);
	/**
	 * a frame captured from view was written, n-bytes long
	 *
	 * This event is emitted in response to capture(...) request. The
	 * current frame of the view is captured and written to the fd
	 * provided. If the view was registered as capture-disabled (see
	 * disable_toplevel_capture), nothing will be written to the fd.
	 * @param size size of the frame in bytes
	 * @param width width of the image
	 * @param height height of the image
	 */
	void (*view_captured)(void *data,
			      struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1,
			      uint32_t size,
			      uint32_t width,
			      uint32_t height);
	/**
	 * a frame captured from view was written, n-bytes long
	 *
	 * This event is emitted in response to start_preview(...)
	 * request. Every t milliseconds, a frame of the view is captured
	 * and written to the fd provided. If the fd was closed externally,
	 * or stop_preview(...) request is issued, further captures will be
	 * stopped, and this signal will no longer be emitted.
	 * @param size size of the frame in bytes
	 * @param width width of the image
	 * @param height height of the image
	 */
	void (*frame_ready)(void *data,
			    struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1,
			    uint32_t size,
			    uint32_t width,
			    uint32_t height);
	/**
	 * info of the underlying process
	 *
	 * This event is emitted in response to get_process_info(...)
	 * request. If the compositor is unable to retrieve the info, then
	 * 0 is returned.
	 * @param pid pid of the underlying process
	 * @param uid uid of the underlying process
	 * @param gid gid of the underlying process
	 */
	void (*process_info)(void *data,
			     struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1,
			     uint32_t pid,
			     uint32_t uid,
			     uint32_t gid);
	/**
	 * emitted when one group of events are finished emitting
	 *
	 * Once the compositor is done emitting a group of events that
	 * need to be treated atomically, this signal is emitted. The next
	 * event that is emitted will belong to the next group of events.
	 * This events will not be emitted after closed(...), or
	 * frame_ready(...) events.
	 */
	void (*done)(void *data,
		     struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1);
};

/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
static inline int
zwayfire_toplevel_v1_add_listener(struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1,
				  const struct zwayfire_toplevel_v1_listener *listener, void *data)
{
	return wl_proxy_add_listener((struct wl_proxy *) zwayfire_toplevel_v1,
				     (void (**)(void)) listener, data);
}

#define ZWAYFIRE_TOPLEVEL_V1_FOCUS 0
#define ZWAYFIRE_TOPLEVEL_V1_MAXIMIZE 1
#define ZWAYFIRE_TOPLEVEL_V1_MINIMIZE 2
#define ZWAYFIRE_TOPLEVEL_V1_RESTORE 3
#define ZWAYFIRE_TOPLEVEL_V1_FULLSCREEN 4
#define ZWAYFIRE_TOPLEVEL_V1_SET_PIN_ABOVE 5
#define ZWAYFIRE_TOPLEVEL_V1_SET_PIN_BELOW 6
#define ZWAYFIRE_TOPLEVEL_V1_SET_STICKY 7
#define ZWAYFIRE_TOPLEVEL_V1_CAPTURE 8
#define ZWAYFIRE_TOPLEVEL_V1_START_PREVIEW 9
#define ZWAYFIRE_TOPLEVEL_V1_STOP_PREVIEW 10
#define ZWAYFIRE_TOPLEVEL_V1_SET_MINIMIZED_GEOMETRY 11
#define ZWAYFIRE_TOPLEVEL_V1_GET_PROCESS_INFO 12
#define ZWAYFIRE_TOPLEVEL_V1_CLOSE 13
#define ZWAYFIRE_TOPLEVEL_V1_KILL 14
#define ZWAYFIRE_TOPLEVEL_V1_DESTROY 15

/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_TITLE_CHANGED_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_APP_ID_CHANGED_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_STATE_CHANGED_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_CLOSED_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_PARENT_CHANGED_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_GEOMETRY_CHANGED_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_VIEW_CAPTURED_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_FRAME_READY_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_PROCESS_INFO_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_DONE_SINCE_VERSION 1

/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_FOCUS_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_MAXIMIZE_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_MINIMIZE_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_RESTORE_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_FULLSCREEN_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_SET_PIN_ABOVE_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_SET_PIN_BELOW_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_SET_STICKY_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_CAPTURE_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_START_PREVIEW_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_STOP_PREVIEW_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_SET_MINIMIZED_GEOMETRY_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_GET_PROCESS_INFO_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_CLOSE_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_KILL_SINCE_VERSION 1
/**
 * @ingroup iface_zwayfire_toplevel_v1
 */
#define ZWAYFIRE_TOPLEVEL_V1_DESTROY_SINCE_VERSION 1

/** @ingroup iface_zwayfire_toplevel_v1 */
static inline void
zwayfire_toplevel_v1_set_user_data(struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) zwayfire_toplevel_v1, user_data);
}

/** @ingroup iface_zwayfire_toplevel_v1 */
static inline void *
zwayfire_toplevel_v1_get_user_data(struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) zwayfire_toplevel_v1);
}

static inline uint32_t
zwayfire_toplevel_v1_get_version(struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_v1);
}

/**
 * @ingroup iface_zwayfire_toplevel_v1
 *
 * Request the compositor to focus this view. If the view is focused, state_changed event
 * will be emitted.
 */
static inline void
zwayfire_toplevel_v1_focus(struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwayfire_toplevel_v1,
			 ZWAYFIRE_TOPLEVEL_V1_FOCUS, NULL, wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_v1), 0);
}

/**
 * @ingroup iface_zwayfire_toplevel_v1
 *
 * Request the compositor to show this view as maximized. Whether the view
 * becomes maximized or not depends on the view. Some views which are of fixed
 * size will not be maximized.
 */
static inline void
zwayfire_toplevel_v1_maximize(struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwayfire_toplevel_v1,
			 ZWAYFIRE_TOPLEVEL_V1_MAXIMIZE, NULL, wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_v1), 0);
}

/**
 * @ingroup iface_zwayfire_toplevel_v1
 *
 * Request the compositor to minimize this view. Whether the view is minimized or not
 * depends on the view. Some views may not support the minimized state, for example
 * most modal dialogs should not be minimized.
 */
static inline void
zwayfire_toplevel_v1_minimize(struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwayfire_toplevel_v1,
			 ZWAYFIRE_TOPLEVEL_V1_MINIMIZE, NULL, wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_v1), 0);
}

/**
 * @ingroup iface_zwayfire_toplevel_v1
 *
 * Request the compositor to restore the previous state of this view. The compositor will
 * try to unmaximize this view if it was maximized, and unminimize the view if it was
 * minimized before this request. If the view was neither maximized, nor minimized then
 * this request will not do anything.
 */
static inline void
zwayfire_toplevel_v1_restore(struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwayfire_toplevel_v1,
			 ZWAYFIRE_TOPLEVEL_V1_RESTORE, NULL, wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_v1), 0);
}

/**
 * @ingroup iface_zwayfire_toplevel_v1
 *
 * Request the compositor to fullscreen/unfullscreen this view. If the view was
 * state_changed event will be sent. When state is 0, output should be null.
 * If the output is null when state is 1, the compositor will decide the screen
 * on which the fullscreen view will be shown.
 */
static inline void
zwayfire_toplevel_v1_fullscreen(struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1, uint32_t state, struct wl_output *output)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwayfire_toplevel_v1,
			 ZWAYFIRE_TOPLEVEL_V1_FULLSCREEN, NULL, wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_v1), 0, state, output);
}

/**
 * @ingroup iface_zwayfire_toplevel_v1
 *
 * Request the compositor to set this view as always on top. If successful,
 * state_changed signal will be emitted.
 */
static inline void
zwayfire_toplevel_v1_set_pin_above(struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1, int32_t on_top)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwayfire_toplevel_v1,
			 ZWAYFIRE_TOPLEVEL_V1_SET_PIN_ABOVE, NULL, wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_v1), 0, on_top);
}

/**
 * @ingroup iface_zwayfire_toplevel_v1
 *
 * Request the compositor to set this view as always on bottom. If successful,
 * state_changed signal will be emitted.
 */
static inline void
zwayfire_toplevel_v1_set_pin_below(struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1, int32_t on_bottom)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwayfire_toplevel_v1,
			 ZWAYFIRE_TOPLEVEL_V1_SET_PIN_BELOW, NULL, wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_v1), 0, on_bottom);
}

/**
 * @ingroup iface_zwayfire_toplevel_v1
 *
 * Request the compositor to set this view as sticky, i.e., show on all desktops.
 * If successful, state_changed signal will be emitted.
 */
static inline void
zwayfire_toplevel_v1_set_sticky(struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1, int32_t sticky)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwayfire_toplevel_v1,
			 ZWAYFIRE_TOPLEVEL_V1_SET_STICKY, NULL, wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_v1), 0, sticky);
}

/**
 * @ingroup iface_zwayfire_toplevel_v1
 *
 * This request captures the contents of this view. The captured contents are stored
 * in a shared memory as uchar *. Use the template "/shm-view-UUID", along with "UUID"
 * as the proj_id to ftok(...) to generate the key to access the shared memory. For
 * example, if the view UUID is 123: key_t key = ftok( "/shm-view-123", 123 );
 *
 * If a disable capture request has been initiated for a toplevel with this view_uuid,
 * then nothing will be stored in the memory. Once the writing is complete,
 * view_captured event will be emitted.
 */
static inline void
zwayfire_toplevel_v1_capture(struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwayfire_toplevel_v1,
			 ZWAYFIRE_TOPLEVEL_V1_CAPTURE, NULL, wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_v1), 0);
}

/**
 * @ingroup iface_zwayfire_toplevel_v1
 *
 * This request captures the contents of this view. The captured contents are stored
 * in a shared memory as uchar *. Use the template "/shm-view-UUID", along with "UUID"
 * as the proj_id to ftok(...) to generate the key to access the shared memory. For
 * example, if the view UUID is 123: key_t key = ftok( "/shm-view-123", 123 );
 *
 * If a disable capture request has been initiated for a toplevel with this view_uuid,
 * then nothing will be stored in the memory. Once the writing is complete, frame_ready
 * event will be emitted.
 */
static inline void
zwayfire_toplevel_v1_start_preview(struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwayfire_toplevel_v1,
			 ZWAYFIRE_TOPLEVEL_V1_START_PREVIEW, NULL, wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_v1), 0);
}

/**
 * @ingroup iface_zwayfire_toplevel_v1
 *
 * Request the compositor to stop capturing the contents of this view.
 */
static inline void
zwayfire_toplevel_v1_stop_preview(struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwayfire_toplevel_v1,
			 ZWAYFIRE_TOPLEVEL_V1_STOP_PREVIEW, NULL, wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_v1), 0);
}

/**
 * @ingroup iface_zwayfire_toplevel_v1
 *
 * The rectangle of the surface specified in this request corresponds to
 * the place where the app using this protocol represents the given toplevel.
 * It can be used by the compositor as a hint for some operations, e.g
 * minimizing. The client is however not required to set this, in which
 * case the compositor is free to decide some default value.
 *
 * If the client specifies more than one rectangle, only the last one is
 * considered.
 *
 * The dimensions are given in surface-local coordinates.
 * Setting width=height=0 removes the already-set rectangle.
 */
static inline void
zwayfire_toplevel_v1_set_minimized_geometry(struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1, struct wl_surface *surface, int32_t x, int32_t y, int32_t width, int32_t height)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwayfire_toplevel_v1,
			 ZWAYFIRE_TOPLEVEL_V1_SET_MINIMIZED_GEOMETRY, NULL, wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_v1), 0, surface, x, y, width, height);
}

/**
 * @ingroup iface_zwayfire_toplevel_v1
 *
 * Request the compositor to send the PID, UID and GID of the process
 * to which this window belongs. The info is sent via the process_info event.
 */
static inline void
zwayfire_toplevel_v1_get_process_info(struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwayfire_toplevel_v1,
			 ZWAYFIRE_TOPLEVEL_V1_GET_PROCESS_INFO, NULL, wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_v1), 0);
}

/**
 * @ingroup iface_zwayfire_toplevel_v1
 *
 * Request the compositor to close this view. The client should not send anymore requests
 * after this.
 */
static inline void
zwayfire_toplevel_v1_close(struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwayfire_toplevel_v1,
			 ZWAYFIRE_TOPLEVEL_V1_CLOSE, NULL, wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_v1), 0);
}

/**
 * @ingroup iface_zwayfire_toplevel_v1
 *
 * Request the compositor to send SIGKILL to this view.
 * NOTE: Sending this request will cause the application to which this view belongs to,
 * to be killed.
 */
static inline void
zwayfire_toplevel_v1_kill(struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwayfire_toplevel_v1,
			 ZWAYFIRE_TOPLEVEL_V1_KILL, NULL, wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_v1), 0);
}

/**
 * @ingroup iface_zwayfire_toplevel_v1
 *
 * Destroys the zwayfire_toplevel_v1 object.
 *
 * This request should be called either when the client does not want to
 * use the toplevel anymore or after the closed event to finalize the
 * destruction of the object.
 */
static inline void
zwayfire_toplevel_v1_destroy(struct zwayfire_toplevel_v1 *zwayfire_toplevel_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) zwayfire_toplevel_v1,
			 ZWAYFIRE_TOPLEVEL_V1_DESTROY, NULL, wl_proxy_get_version((struct wl_proxy *) zwayfire_toplevel_v1), WL_MARSHAL_FLAG_DESTROY);
}

#ifdef  __cplusplus
}
#endif

#endif
