/* Generated by wayland-scanner 1.23.0 */

/*
 * Copyright © 2018 Ilia Bozhinov
 * Copyright © 2023 Marcus Britanicus
 *
 * Permission to use, copy, modify, distribute, and sell this
 * software and its documentation for any purpose is hereby granted
 * without fee, provided that the above copyright notice appear in
 * all copies and that both that copyright notice and this permission
 * notice appear in supporting documentation, and that the name of
 * the copyright holders not be used in advertising or publicity
 * pertaining to distribution of the software without specific,
 * written prior permission.  The copyright holders make no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied
 * warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
 * THIS SOFTWARE.
 */

#include <stdbool.h>
#include <stdlib.h>
#include <stdint.h>
#include "wayland-util.h"

#ifndef __has_attribute
# define __has_attribute(x) 0  /* Compatibility with non-clang compilers. */
#endif

#if (__has_attribute(visibility) || defined(__GNUC__) && __GNUC__ >= 4)
#define WL_PRIVATE __attribute__ ((visibility("hidden")))
#else
#define WL_PRIVATE
#endif

extern const struct wl_interface wl_output_interface;
extern const struct wl_interface wl_surface_interface;
extern const struct wl_interface zdesq_hotspot_v1_interface;
extern const struct wl_interface zdesq_output_v1_interface;
extern const struct wl_interface zdesq_panel_v1_interface;
extern const struct wl_interface zdesq_surface_v1_interface;

static const struct wl_interface *desq_shell_unstable_v1_types[] = {
	NULL,
	NULL,
	NULL,
	&wl_output_interface,
	&zdesq_output_v1_interface,
	&wl_surface_interface,
	&zdesq_surface_v1_interface,
	&wl_surface_interface,
	&wl_output_interface,
	&wl_output_interface,
	&wl_surface_interface,
	&wl_output_interface,
	&wl_surface_interface,
	&zdesq_panel_v1_interface,
	NULL,
	NULL,
	NULL,
	&zdesq_hotspot_v1_interface,
};

static const struct wl_message zdesq_shell_manager_v1_requests[] = {
	{ "get_desq_output", "on", desq_shell_unstable_v1_types + 3 },
	{ "get_desq_surface", "on", desq_shell_unstable_v1_types + 5 },
	{ "set_background", "o?o", desq_shell_unstable_v1_types + 7 },
	{ "set_dropdown", "?oo", desq_shell_unstable_v1_types + 9 },
	{ "create_panel", "oon", desq_shell_unstable_v1_types + 11 },
};

WL_PRIVATE const struct wl_interface zdesq_shell_manager_v1_interface = {
	"zdesq_shell_manager_v1", 1,
	5, zdesq_shell_manager_v1_requests,
	0, NULL,
};

static const struct wl_message zdesq_output_v1_requests[] = {
	{ "inhibit_output", "", desq_shell_unstable_v1_types + 0 },
	{ "inhibit_output_done", "", desq_shell_unstable_v1_types + 0 },
	{ "create_hotspot", "uuun", desq_shell_unstable_v1_types + 14 },
	{ "get_workspace_extents", "", desq_shell_unstable_v1_types + 0 },
	{ "get_active_workspace", "", desq_shell_unstable_v1_types + 0 },
	{ "set_active_workspace", "ii", desq_shell_unstable_v1_types + 0 },
};

static const struct wl_message zdesq_output_v1_events[] = {
	{ "enter_fullscreen", "", desq_shell_unstable_v1_types + 0 },
	{ "leave_fullscreen", "", desq_shell_unstable_v1_types + 0 },
	{ "workspace_extents", "ii", desq_shell_unstable_v1_types + 0 },
	{ "active_workspace", "ii", desq_shell_unstable_v1_types + 0 },
	{ "view_added", "uii", desq_shell_unstable_v1_types + 0 },
	{ "view_removed", "uii", desq_shell_unstable_v1_types + 0 },
	{ "done", "", desq_shell_unstable_v1_types + 0 },
};

WL_PRIVATE const struct wl_interface zdesq_output_v1_interface = {
	"zdesq_output_v1", 1,
	6, zdesq_output_v1_requests,
	7, zdesq_output_v1_events,
};

static const struct wl_message zdesq_hotspot_v1_events[] = {
	{ "enter", "", desq_shell_unstable_v1_types + 0 },
	{ "leave", "", desq_shell_unstable_v1_types + 0 },
};

WL_PRIVATE const struct wl_interface zdesq_hotspot_v1_interface = {
	"zdesq_hotspot_v1", 1,
	0, NULL,
	2, zdesq_hotspot_v1_events,
};

static const struct wl_message zdesq_surface_v1_requests[] = {
	{ "interactive_move", "", desq_shell_unstable_v1_types + 0 },
};

WL_PRIVATE const struct wl_interface zdesq_surface_v1_interface = {
	"zdesq_surface_v1", 1,
	1, zdesq_surface_v1_requests,
	0, NULL,
};

static const struct wl_message zdesq_panel_v1_requests[] = {
	{ "set_panel_size", "u", desq_shell_unstable_v1_types + 0 },
	{ "set_panel_behavior", "u", desq_shell_unstable_v1_types + 0 },
	{ "set_panel_position", "u", desq_shell_unstable_v1_types + 0 },
	{ "set_panel_orientation", "u", desq_shell_unstable_v1_types + 0 },
};

WL_PRIVATE const struct wl_interface zdesq_panel_v1_interface = {
	"zdesq_panel_v1", 1,
	4, zdesq_panel_v1_requests,
	0, NULL,
};

