/* Generated by wayland-scanner 1.23.0 */

/*
 * Copyright © 2018 Ilia Bozhinov
 * Copyright © 2023 Marcus Britanicus
 *
 * Permission to use, copy, modify, distribute, and sell this
 * software and its documentation for any purpose is hereby granted
 * without fee, provided that the above copyright notice appear in
 * all copies and that both that copyright notice and this permission
 * notice appear in supporting documentation, and that the name of
 * the copyright holders not be used in advertising or publicity
 * pertaining to distribution of the software without specific,
 * written prior permission.  The copyright holders make no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied
 * warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
 * THIS SOFTWARE.
 */

#include <stdbool.h>
#include <stdlib.h>
#include <stdint.h>
#include "wayland-util.h"

#ifndef __has_attribute
# define __has_attribute(x) 0  /* Compatibility with non-clang compilers. */
#endif

#if (__has_attribute(visibility) || defined(__GNUC__) && __GNUC__ >= 4)
#define WL_PRIVATE __attribute__ ((visibility("hidden")))
#else
#define WL_PRIVATE
#endif

extern const struct wl_interface wl_output_interface;
extern const struct wl_interface wl_surface_interface;
extern const struct wl_interface zwayfire_toplevel_v1_interface;

static const struct wl_interface *zwayfire_toplevel_management_v1_types[] = {
	NULL,
	NULL,
	NULL,
	NULL,
	&zwayfire_toplevel_v1_interface,
	NULL,
	&zwayfire_toplevel_v1_interface,
	NULL,
	NULL,
	&wl_output_interface,
	&wl_surface_interface,
	NULL,
	NULL,
	NULL,
	NULL,
};

static const struct wl_message zwayfire_toplevel_manager_v1_requests[] = {
	{ "get_toplevel_for_uuid", "u", zwayfire_toplevel_management_v1_types + 0 },
	{ "toplevels", "", zwayfire_toplevel_management_v1_types + 0 },
	{ "capture_toplevel", "u", zwayfire_toplevel_management_v1_types + 0 },
	{ "disable_toplevel_capture", "uu", zwayfire_toplevel_management_v1_types + 0 },
	{ "stop", "", zwayfire_toplevel_management_v1_types + 0 },
};

static const struct wl_message zwayfire_toplevel_manager_v1_events[] = {
	{ "new_toplevel", "nu", zwayfire_toplevel_management_v1_types + 4 },
	{ "toplevel", "ou", zwayfire_toplevel_management_v1_types + 6 },
	{ "finished", "", zwayfire_toplevel_management_v1_types + 0 },
	{ "done", "", zwayfire_toplevel_management_v1_types + 0 },
};

WL_PRIVATE const struct wl_interface zwayfire_toplevel_manager_v1_interface = {
	"zwayfire_toplevel_manager_v1", 1,
	5, zwayfire_toplevel_manager_v1_requests,
	4, zwayfire_toplevel_manager_v1_events,
};

static const struct wl_message zwayfire_toplevel_v1_requests[] = {
	{ "focus", "", zwayfire_toplevel_management_v1_types + 0 },
	{ "maximize", "", zwayfire_toplevel_management_v1_types + 0 },
	{ "minimize", "", zwayfire_toplevel_management_v1_types + 0 },
	{ "restore", "", zwayfire_toplevel_management_v1_types + 0 },
	{ "fullscreen", "u?o", zwayfire_toplevel_management_v1_types + 8 },
	{ "set_pin_above", "i", zwayfire_toplevel_management_v1_types + 0 },
	{ "set_pin_below", "i", zwayfire_toplevel_management_v1_types + 0 },
	{ "set_sticky", "i", zwayfire_toplevel_management_v1_types + 0 },
	{ "capture", "", zwayfire_toplevel_management_v1_types + 0 },
	{ "start_preview", "", zwayfire_toplevel_management_v1_types + 0 },
	{ "stop_preview", "", zwayfire_toplevel_management_v1_types + 0 },
	{ "set_minimized_geometry", "oiiii", zwayfire_toplevel_management_v1_types + 10 },
	{ "get_process_info", "", zwayfire_toplevel_management_v1_types + 0 },
	{ "close", "", zwayfire_toplevel_management_v1_types + 0 },
	{ "kill", "", zwayfire_toplevel_management_v1_types + 0 },
	{ "destroy", "", zwayfire_toplevel_management_v1_types + 0 },
};

static const struct wl_message zwayfire_toplevel_v1_events[] = {
	{ "title_changed", "ss", zwayfire_toplevel_management_v1_types + 0 },
	{ "app_id_changed", "ss", zwayfire_toplevel_management_v1_types + 0 },
	{ "state_changed", "uu", zwayfire_toplevel_management_v1_types + 0 },
	{ "closed", "", zwayfire_toplevel_management_v1_types + 0 },
	{ "parent_changed", "uu", zwayfire_toplevel_management_v1_types + 0 },
	{ "geometry_changed", "iiii", zwayfire_toplevel_management_v1_types + 0 },
	{ "view_captured", "uuu", zwayfire_toplevel_management_v1_types + 0 },
	{ "frame_ready", "uuu", zwayfire_toplevel_management_v1_types + 0 },
	{ "process_info", "uuu", zwayfire_toplevel_management_v1_types + 0 },
	{ "done", "", zwayfire_toplevel_management_v1_types + 0 },
};

WL_PRIVATE const struct wl_interface zwayfire_toplevel_v1_interface = {
	"zwayfire_toplevel_v1", 1,
	16, zwayfire_toplevel_v1_requests,
	10, zwayfire_toplevel_v1_events,
};

